#ifndef BTREE_H
#define BTREE_H

#include <iostream.h>
#include <malloc.h>
#include <math.h>
#include "pp.h"

class mObj2D;

class bbTree;

class bbTNode {
  
 public:

  bbTNode *lson, *rson, *parent, *mindes;
  bbTree *tree;
  int minskey;
  mObj2D *point;
  short color;
  int rank;
  bbTNode();
  bbTNode(bbTNode*);
  bbTNode(mObj2D*,short);
  bbTNode(mObj2D*,short,bbTNode*);
  void makeNode(mObj2D*,short);
  void makeNode(mObj2D*,short,bbTNode*);
  void reset(void);
  void reset(short);
  inline short isleaf() { return (lson==NULL)&&(rson==NULL); }
  inline short isroot() { return parent==NULL;}
  inline short islson() { return isroot()?0:(parent->lson==this);}
  inline short isrson() { return isroot()?0:parent->rson==this;} 
  void printValue(void);
  void printIn(void);
  void printPost(void);
  void printPre(void);
  void printValue(short);
  void printIn(short);
  void printPost(short);
  void printPre(short);
  bbTNode* rotate(short,short);
  void update(short);
  void updateup(short);
  void deleteNode(void);
  bbTNode *root(void);
  bbTree *relTree(void);
  verify(void);
  void decompose(short);
  short compare(bbTNode* );
//  ~bbTNode(void);
};

inline short
Color(bbTNode* bn) { return (bn)?(bn->color):BLACK; }

class bbTree {

public:

  bbTNode *root;
  short ax;
  mObj2D *relmo;
  bbTree(void);
  bbTree(short a);
  bbTree(bbTNode* r);
  bbTree(bbTNode* r, short a);
  bbTree(mObj2D* rl, short a);
  bbTree(mObj2D* rl, bbTNode* r);
  bbTree(mObj2D* rl, bbTNode* r, short a); 
  bbTree* cut(bbTNode*);
  void makeTree(bbTNode*, short);
  void makeTree(mObj2D*, short);
  void makeTree(mObj2D*, bbTNode*, short);
  void setrelmo(mObj2D*);
  void setAxis(short axis) { ax = axis;}

  int bheight(void);

  void insfix(bbTNode*);
  bbTNode* insert(bbTNode*,short);
  bbTNode* tinsert(bbTNode*, short);

  void delfix(bbTNode*,bbTNode*,short);
  bbTNode* del(bbTNode*);
  bbTNode* tdel(bbTNode*,short*,bbTNode**,short*);

  bbTNode* search(int,short,short*);
  bbTNode* search(mObj2D*,short,short*);

  void ljoinwith(bbTree*);
  void ljoinwith(bbTree*, bbTNode*);
  void rjoinwith(bbTree*);
  void rjoinwith(bbTree*, bbTNode*);
  void join(bbTree*, bbTree*, bbTNode*);

  void split(bbTree*, bbTree*, bbTNode*, short);
  void split(bbTree*, bbTree*, mObj2D*, short);
  void split(bbTree*, bbTree*, int, short);
  void split(bbTree*, bbTNode*, short, short);
  void split(bbTree*, mObj2D*, short, short);
  void split(bbTree*, int, short, short);
//  rotate(bbTNode*, short);
  bbTNode* minSkey(void);
  bbTNode* min(void);
  bbTNode* max(void);
  void decompose(void);
  void deleteTree(void);
  void printTreeIn(void);
  void printTreePost(void);
  void printTreePre(void);
  void printTreeIn(short);
  void printTreePost(short);
  void printTreePre(short);
  short compare(bbTree*);
};

#endif  





