
#include "mainctl.h"
#include "newmotion.h"
#include "generate.h"
#include "draw.h"
#include "kine.h"
#include <stdlib.h>
#include <stdio.h>

extern FD_controlpanel *fmcp;
extern FD_newmotion *fnm;
extern FD_generate *fgen;
extern FD_drawingwindow *fdraw;
extern mObjs *mos;

void initialize(FD_controlpanel *fdui) {

  fl_addto_choice(fdui->config,"Closest Pair");
  fl_addto_choice(fdui->config,"Convex Hull");
  fl_addto_choice(fdui->config,"Delaunay");
  fl_addto_choice(fdui->config,"MST");
}

void initsetup(FD_controlpanel *fdui) {

  fl_deactivate_object(fdui->stop);
  fl_deactivate_object(fdui->cont);
  fl_deactivate_object(fdui->next);
  fl_deactivate_object(fdui->quit);
}
 


void do_play(FL_OBJECT *obj, long arg) {

  fl_set_idle_callback(drawindow,0);
  fl_show_form(fdraw->drawingwindow, FL_PLACE_MOUSE,FL_FULLBORDER,"Draw");
  fl_deactivate_object(fmcp->play);
  fl_activate_object(fmcp->quit);
  fl_activate_object(fmcp->stop);
  initparameters();
  glinit();
}

void do_stop(FL_OBJECT *obj, long arg) {
  
  
  printf("Stop\n");
}

void do_cont(FL_OBJECT *obj, long arg) {
  
  printf("Cont\n");
}

void do_next(FL_OBJECT *obj, long arg) {

  printf("Next\n");
}

void do_quit(FL_OBJECT *obj, long arg) {
  
  fl_set_idle_callback(0,0);
  //fl_hide_object(fdraw->drawindow);
  //fl_free_object(fdraw->drawindow);
  fl_hide_form(fdraw->drawingwindow);
 // fl_free_form(fdraw->drawingwindow);
 // fl_free(fdraw);
  fl_activate_object(fmcp->play);
  fl_deactivate_object(fmcp->quit);
  delete mos;
}

void do_new(FL_OBJECT *obj, long arg) {

  fnm = create_form_newmotion();
  fl_deactivate_form(fmcp->controlpanel);
  fl_show_form(fnm->newmotion, FL_PLACE_MOUSE,FL_TRANSIENT,"Input Objects");
}

void do_exit(FL_OBJECT *obj, long arg) {
  
  printf("Bye bye\n");
  exit(0);
}

void choose_config(FL_OBJECT *obj, long data) {}
void choose_balloption(FL_OBJECT *obj, long data) {}
void choose_ballradius(FL_OBJECT *obj, long data) {}
void choose_paddle(FL_OBJECT *obj, long data) {}
void choose_dynins(FL_OBJECT *obj, long data) {}
void choose_speed(FL_OBJECT *obj, long data) {}
void choose_3d(FL_OBJECT *obj, long data) {}
void choose_contoption(FL_OBJECT *obj, long data) {}
void choose_showcert(FL_OBJECT *obj, long data) {}

