#include "pp.h"

void 
sort(P2 *points, 
     int size,
     int *resultList, 
     short dim,
     short order) {
  
/* heap sorting - the first sorting program faster than O(n^2)
   I have ever written*/

  int i,left,right,next,current,temp;
  
  if(size==0) return;
  
  for(i=0;i<size;i++) 
    resultList[i] = i;
  
// build heap

  for(i=size/2-1;i>=0;i--) {

    left = LS(i);
    right = RS(i);
    next = i;
    current = i;
    while(left<size) {
      
      if(compare(points[resultList[current]],
		 points[resultList[left]],dim,order))
	next = left;
      if(right<size) 
	if(compare(points[resultList[next]],
		   points[resultList[right]],dim,order)) 
	  next = right;
      if(next==current) break;
      temp = resultList[current];
      resultList[current] = resultList[next];
      resultList[next] = temp;
      current = next;
      left = LS(current);
      right = RS(current);
    }
  }
  
//extract element one by one
  
  for(i=size-1;i>=1;i--) {
    
    temp = resultList[i];
    resultList[i] = resultList[0];
    resultList[0] = temp;
    
    left = LS(0);
    right = RS(0);
    next = 0;
    current = 0;
    while(left<i) {
      
      if(compare(points[resultList[current]],
		 points[resultList[left]],dim,order))
	next = left;
      if((right<i) && 
	 compare(points[resultList[next]],
	 points[resultList[right]],dim,order)) 
	    next = right;
      if(next==current) break;
      temp = resultList[current];
      resultList[current] = resultList[next];
      resultList[next] = temp;
      current = next;
      left = LS(current);
      right = RS(current);
    }
  }
}

void 
sort(REAL* ulist,
     int* sortedlist,
     int size,
     short order) {
  
  /* heap sorting - the first sorting program faster than O(n^2)
     I have ever written*/
  
  int i,left,right,next,current,temp;
  
  if(size==0) return;
  
  for(i=0;i<size;i++)
    sortedlist[i] = i;
  
  // build heap

  if(order==INCREASING) {
    for(i=size/2-1;i>=0;i--) {
      
      left = LS(i);
      right = RS(i);
      next = i;
      current = i;
      while(left<size) {
	
	if(ulist[sortedlist[current]] < ulist[sortedlist[left]])
	  next = left;
	if((right<size)&&(ulist[sortedlist[next]]<ulist[sortedlist[right]]))
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
    
    //extract element one by one
    
    for(i=size-1;i>=1;i--) {
      
      temp = sortedlist[i];
      sortedlist[i] = sortedlist[0];
      sortedlist[0] = temp;

      left = 1;
      right = 2;
      next = 0;
      current = 0;
      while(left<i) {
	
	if(ulist[sortedlist[current]]<ulist[sortedlist[left]])
	  next = left;
	if((right<i) && (ulist[sortedlist[next]]<ulist[sortedlist[right]])) 
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
  } else {
    
    for(i=size/2-1;i>=0;i--) {
      
      left = LS(i);
      right = RS(i);
      next = i;
      current = i;
      while(left<size) {
	
	if(ulist[sortedlist[current]] > ulist[sortedlist[left]])
	  next = left;
	if((right<size)&&(ulist[sortedlist[next]]>ulist[sortedlist[right]]))
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
    
    //extract element one by one
    
    for(i=size-1;i>=1;i--) {
      
      temp = sortedlist[i];
      sortedlist[i] = sortedlist[0];
      sortedlist[0] = temp;

      left = 1;
      right = 2;
      next = 0;
      current = 0;
      while(left<i) {
	
	if(ulist[sortedlist[current]]>ulist[sortedlist[left]])
	  next = left;
	if((right<i) && (ulist[sortedlist[next]]>ulist[sortedlist[right]])) 
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
  }
}

void 
sort2(REAL* ulist,
      REAL* vlist,
      int* sortedlist,
      int size,
      short order) {
  
  /* heap sorting - the first sorting program faster than O(n^2)
     I have ever written*/
  
  int i,left,right,next,current,temp;
  
  if(size==0) return;
  
  for(i=0;i<size;i++)
    sortedlist[i] = i;
  
  // build heap

  if(order==INCREASING) {
    for(i=size/2-1;i>=0;i--) {
      
      left = LS(i);
      right = RS(i);
      next = i;
      current = i;
      while(left<size) {
	
	if(lessthan(ulist,vlist,sortedlist[current], sortedlist[left]))
	  next = left;
	if((right<size)&&
	   lessthan(ulist,vlist,sortedlist[next],sortedlist[right]))
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
    
    //extract element one by one
    
    for(i=size-1;i>=1;i--) {
      
      temp = sortedlist[i];
      sortedlist[i] = sortedlist[0];
      sortedlist[0] = temp;

      left = 1;
      right = 2;
      next = 0;
      current = 0;
      while(left<i) {
	
	if(lessthan(ulist,vlist,sortedlist[current],sortedlist[left]))
	  next = left;
	if((right<i) && 
	   lessthan(ulist,vlist,sortedlist[next],sortedlist[right])) 
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
  } else {
    
    for(i=size/2-1;i>=0;i--) {
      
      left = LS(i);
      right = RS(i);
      next = i;
      current = i;
      while(left<size) {
	
	if(greaterthan(ulist,vlist,sortedlist[current], sortedlist[left]))
	  next = left;
	if((right<size)&&
	   greaterthan(ulist,vlist,sortedlist[next],sortedlist[right]))
	  next = right;
	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
    
    //extract element one by one
    
    for(i=size-1;i>=1;i--) {
      
      temp = sortedlist[i];
      sortedlist[i] = sortedlist[0];
      sortedlist[0] = temp;

      left = 1;
      right = 2;
      next = 0;
      current = 0;
      while(left<i) {
	
	if(greaterthan(ulist,vlist,sortedlist[current],sortedlist[left]))
	  next = left;
	if((right<i) && 
	   greaterthan(ulist,vlist,sortedlist[next],sortedlist[right])) 
	  next = right;

	if(next==current) break;
	temp = sortedlist[current];
	sortedlist[current] = sortedlist[next];
	sortedlist[next] = temp;
	current = next;
	left = LS(current);
	right = RS(current);
      }
    }
  }
}
  
void 
rotate(P2 p1, P2 p2, short axis) {
  
  REAL ctheta,stheta;
  
  switch(axis) {
    
  case X:
    
    ctheta = 1;
    stheta = 0;
    break;
    
  case X60:
    
    ctheta = c60;
    stheta = s60;
    break; 
    
  case X120:
    
    ctheta = c120;
    stheta = s120;
    break;

  case X180:
    
    ctheta = -1;
    stheta = 0;
    break; 
    
  case X240:
    
    ctheta = c240;
    stheta = s240;
    break; 
    
  case X300:
  
    ctheta = c300;
    stheta = s300;
    break;

  case X360:

    ctheta = 1;
    stheta = 0;
    
  }
  
  p2[X] =  p1[X]*ctheta + p1[Y]*stheta;
  p2[Y] = (-p1[X]*stheta) + p1[Y]*ctheta;
} 

void
rotate(P2 *pp, int size, P2 *np, short axis) {
  
  REAL ctheta,stheta;
  int i;
  
  switch(axis) {
    
  case X:
    
    ctheta = 1;
    stheta = 0;
    break;
    
  case X60:
    
    ctheta = c60;
    stheta = s60;
    break; 
    
  case X120:
    
    ctheta = c120;
    stheta = s120;
    break;

  case X180:
    
    ctheta = -1;
    stheta = 0;
    break; 
    
  case X240:
    
    ctheta = c240;
    stheta = s240;
    break; 
    
  case X300:
  
    ctheta = c300;
    stheta = s300;
    break;

  case X360:
  
    ctheta = 1;
    stheta = 0;
    break;
  }
  
  for(i=0;i<size;i++) {
    np[i][X] =  pp[i][X]*ctheta + pp[i][Y]*stheta;
    np[i][Y] = (-pp[i][X]*stheta) + pp[i][Y]*ctheta;
  }
}
  
